VERSION 5.00
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.3#0"; "COMCTL32.OCX"
Begin VB.Form frmAnalogBank 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Analog Bank Details"
   ClientHeight    =   6495
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   8745
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   6495
   ScaleWidth      =   8745
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton CloseBtn 
      Caption         =   "&Close"
      Default         =   -1  'True
      Height          =   375
      Left            =   240
      TabIndex        =   1
      Top             =   5880
      Width           =   1335
   End
   Begin VB.Timer Timer1 
      Interval        =   1000
      Left            =   2400
      Top             =   5880
   End
   Begin VB.Frame Frame1 
      Caption         =   "Read Area"
      Height          =   5295
      Left            =   240
      TabIndex        =   0
      Top             =   240
      Width           =   8175
      Begin ComctlLib.ListView ReadListView 
         Height          =   4695
         Left            =   240
         TabIndex        =   2
         Top             =   360
         Width           =   7695
         _ExtentX        =   13573
         _ExtentY        =   8281
         View            =   3
         LabelWrap       =   -1  'True
         HideSelection   =   -1  'True
         _Version        =   327682
         ForeColor       =   -2147483640
         BackColor       =   -2147483643
         BorderStyle     =   1
         Appearance      =   1
         NumItems        =   5
         BeginProperty ColumnHeader(1) {0713E8C7-850A-101B-AFC0-4210102A8DA7} 
            Key             =   ""
            Object.Tag             =   ""
            Text            =   "Point"
            Object.Width           =   1270
         EndProperty
         BeginProperty ColumnHeader(2) {0713E8C7-850A-101B-AFC0-4210102A8DA7} 
            SubItemIndex    =   1
            Key             =   ""
            Object.Tag             =   ""
            Text            =   "Value"
            Object.Width           =   2540
         EndProperty
         BeginProperty ColumnHeader(3) {0713E8C7-850A-101B-AFC0-4210102A8DA7} 
            SubItemIndex    =   2
            Key             =   ""
            Object.Tag             =   ""
            Text            =   "Counts"
            Object.Width           =   2540
         EndProperty
         BeginProperty ColumnHeader(4) {0713E8C7-850A-101B-AFC0-4210102A8DA7} 
            SubItemIndex    =   3
            Key             =   ""
            Object.Tag             =   ""
            Text            =   "Min Value"
            Object.Width           =   2540
         EndProperty
         BeginProperty ColumnHeader(5) {0713E8C7-850A-101B-AFC0-4210102A8DA7} 
            SubItemIndex    =   4
            Key             =   ""
            Object.Tag             =   ""
            Text            =   "Max Value"
            Object.Width           =   2540
         EndProperty
      End
   End
End
Attribute VB_Name = "frmAnalogBank"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub CloseBtn_Click()
  Unload Me
End Sub

Private Sub Form_Load()
    Dim i As Long
    
  ' Add items to the listview
  For i = 0 To 63
    Dim li As ListItem
    
    Set li = ReadListView.ListItems.Add()
    li.Text = Format(i)
  Next i
End Sub


Private Sub Timer1_Timer()
  Dim nResult As Long
  Dim BankValues As SIOMM_AnaBank
  Dim BankCounts As SIOMM_AnaBank
  Dim BankMinValues As SIOMM_AnaBank
  Dim BankMaxValues As SIOMM_AnaBank
  
  ' Get each area of the analog bank area
  nResult = gBrain.GetAnaBankValuesEx(BankValues)
  If (nResult = SIOMM_OK) Then
    nResult = gBrain.GetAnaBankCountsEx(BankCounts)
    If (nResult = SIOMM_OK) Then
      nResult = gBrain.GetAnaBankMinValuesEx(BankMinValues)
      If (nResult = SIOMM_OK) Then
        nResult = gBrain.GetAnaBankMaxValuesEx(BankMaxValues)
        
        If (nResult = SIOMM_OK) Then
          Dim i As Long
          Dim str As String
    
    
          ' Loop through the analog bank and update the listview
          For i = 0 To 63
            Dim li As ListItem
        
            ' Get the listview item
            Set li = ReadListView.ListItems.Item(i + 1)
            
            ' Values
            str = Format(BankValues.fValue(i))
            If (str = "-1.#QNAN") Then
              str = "" ' Print nothing if the float is Not-A-Number
            End If
            li.SubItems(1) = str
            
            ' Counts
            str = Format(BankCounts.fValue(i))
            If (str = "-1.#QNAN") Then
              str = "" ' Print nothing if the float is Not-A-Number
            End If
            li.SubItems(2) = str
            
            ' Min Values
            str = Format(BankMinValues.fValue(i))
            If (str = "-1.#QNAN") Then
              str = "" ' Print nothing if the float is Not-A-Number
            End If
            li.SubItems(3) = str
            
            ' Max Values
            str = Format(BankMaxValues.fValue(i))
            If (str = "-1.#QNAN") Then
              str = "" ' Print nothing if the float is Not-A-Number
            End If
            li.SubItems(4) = str
            
          Next i
        End If
      End If
    End If
  End If

  ' Handle any errors
  fMainForm.HandleError (nResult)

End Sub
