VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "Msflxgrd.ocx"
Begin VB.Form fMainForm 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "OptoSnapIoMemMapX Scratch Pad Example "
   ClientHeight    =   7920
   ClientLeft      =   840
   ClientTop       =   2730
   ClientWidth     =   13395
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   7920
   ScaleWidth      =   13395
   Begin VB.Frame Frame3 
      Caption         =   "Commands"
      Height          =   2895
      Left            =   120
      TabIndex        =   12
      Top             =   4800
      Width           =   2175
      Begin VB.CommandButton ClearAllStringsBtn 
         Caption         =   "Clear All Strings"
         Height          =   375
         Left            =   240
         TabIndex        =   17
         Top             =   2280
         Width           =   1455
      End
      Begin VB.CommandButton ClearAllFloatsBtn 
         Caption         =   "Clear All Floats"
         Height          =   375
         Left            =   240
         TabIndex        =   16
         Top             =   1800
         Width           =   1455
      End
      Begin VB.CommandButton ClearAllBitsBtn 
         Caption         =   "Clear All Bits"
         Height          =   375
         Left            =   240
         TabIndex        =   15
         Top             =   840
         Width           =   1455
      End
      Begin VB.CommandButton ClearAllBtn 
         Caption         =   "Clear All"
         Height          =   375
         Left            =   240
         TabIndex        =   14
         Top             =   360
         Width           =   1455
      End
      Begin VB.CommandButton ClearAllIntsBtn 
         Caption         =   "Clear All Integers"
         Height          =   375
         Left            =   240
         TabIndex        =   13
         Top             =   1320
         Width           =   1455
      End
   End
   Begin VB.TextBox Text1 
      Alignment       =   1  'Right Justify
      BorderStyle     =   0  'None
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   285
      Left            =   4080
      TabIndex        =   11
      Text            =   "Text1"
      Top             =   1800
      Visible         =   0   'False
      Width           =   1095
   End
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   250
      Left            =   2160
      Top             =   3000
   End
   Begin MSFlexGridLib.MSFlexGrid Grid1 
      Height          =   7575
      Left            =   2520
      TabIndex        =   10
      Top             =   120
      Width           =   10695
      _ExtentX        =   18865
      _ExtentY        =   13361
      _Version        =   393216
      Rows            =   1026
      Cols            =   6
      FocusRect       =   2
      HighLight       =   0
      FillStyle       =   1
      AllowUserResizing=   1
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
   End
   Begin VB.Frame Frame1 
      Caption         =   "Configuration"
      Height          =   2895
      Left            =   120
      TabIndex        =   3
      Top             =   120
      Width           =   2175
      Begin VB.TextBox IpAddressEdit 
         Height          =   285
         Left            =   240
         TabIndex        =   7
         Text            =   "10.192.54.0"
         Top             =   600
         Width           =   1695
      End
      Begin VB.CommandButton ConnectBtn 
         Caption         =   "Connect"
         Height          =   375
         Left            =   240
         TabIndex        =   6
         Top             =   1800
         Width           =   1455
      End
      Begin VB.CommandButton DisconnectBtn 
         Caption         =   "Disconnect"
         Height          =   375
         Left            =   240
         TabIndex        =   5
         Top             =   2280
         Width           =   1455
      End
      Begin VB.TextBox PortNumberEdit 
         Height          =   285
         Left            =   240
         TabIndex        =   4
         Text            =   "2001"
         Top             =   1320
         Width           =   1695
      End
      Begin VB.Label Label1 
         Caption         =   "IP Address of SNAP I/O:"
         Height          =   255
         Left            =   240
         TabIndex        =   9
         Top             =   360
         Width           =   1815
      End
      Begin VB.Label Label2 
         Caption         =   "Port Number:"
         Height          =   255
         Left            =   240
         TabIndex        =   8
         Top             =   1080
         Width           =   1575
      End
   End
   Begin VB.Frame Frame2 
      Caption         =   "Status"
      Height          =   1575
      Left            =   120
      TabIndex        =   0
      Top             =   3120
      Width           =   2175
      Begin VB.TextBox ErrorEdit 
         BackColor       =   &H00FFFFFF&
         Height          =   765
         Left            =   240
         MultiLine       =   -1  'True
         TabIndex        =   1
         Top             =   600
         Width           =   1695
      End
      Begin VB.Label Label3 
         Caption         =   "Error: "
         Height          =   255
         Left            =   240
         TabIndex        =   2
         Top             =   360
         Width           =   855
      End
   End
End
Attribute VB_Name = "fMainForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'********************************************************************************
' SNAP Ethernet I/O and Ultimate I/O Scratch Pad Example
'
' Written in Visual Basic 6.0
'
' This example shows how to use the OptoSnapIoMemMapX ActiveX component to
' communicate with the scratch pad aread of SNAP Ethernet and Ultimate brains.
'
' Copyright (c) 2002, Opto 22
'
'********************************************************************************


Option Explicit

' Position of each column in the grid
Const COLUMN_BITS = 1
Const COLUMN_INTS = 2
Const COLUMN_FLTS = 3
Const COLUMN_STR_LEN = 4
Const COLUMN_STR_DATA = 5


Public gBrain As OptoSnapIoMemMapX


Public Sub HandleError(nResult As Long)
  
  ' Update the error message
  ErrorEdit.Text = GetResultAsString(nResult)
  
  If (nResult = SIOMM_OK) Then
    ' Set background to white
    ErrorEdit.BackColor = &HFFFFFF
  Else
    ' Set background to red
    ErrorEdit.BackColor = &HFF&
    
    ' shutdown everything on a bad error
    If (nResult <> SIOMM_ERROR_NOT_CONNECTED_YET) Then
      gBrain.Close
      Timer1.Enabled = False
      
      DisableConnectedControls
    End If
  End If

End Sub


Private Sub ConnectBtn_Click()
  Dim nResult As Long
  
  ' Attempt to open the B3000...
  nResult = OpenSnapIoWithCancel(gBrain, IpAddressEdit.Text, PortNumberEdit.Text, 10000)
  
  ' Check the result
  HandleError (nResult)
  
  ' If no error, then enable the timer
  If (nResult = 1) Then
    Timer1.Enabled = True
    
    EnableConnectedControls
    
  End If
  
End Sub


Private Sub DisconnectBtn_Click()
  Timer1.Enabled = False
  Dim nResult As Long
    
  ' Close the connection to the brain
  nResult = gBrain.Close()
  
  If (nResult = SIOMM_OK) Then
    ' Show the "not connected" error
    HandleError (SIOMM_ERROR_NOT_CONNECTED)
  Else
    HandleError (nResult)
  End If
  
  DisableConnectedControls
  
End Sub


Private Sub ClearAllBtn_Click()
  ' Clear everything out
  ClearAllBitsBtn_Click
  ClearAllIntsBtn_Click
  ClearAllFloatsBtn_Click
  ClearAllStringsBtn_Click
End Sub


Private Sub ClearAllBitsBtn_Click()
  Dim nResult As Long

  ' Turn all the bits off
  nResult = gBrain.SetScratchPadBitAreaMask(0, 0, &HFFFFFFFF, &HFFFFFFFF)
  
  HandleError (nResult)
End Sub


Private Sub ClearAllIntsBtn_Click()
  Dim spInt As OptoSnapIoMemMapXlib.SIOMM_ScratchPadIntegerBlock
  Dim nResult As Long
  Dim i As Long
  Dim j As Long
  
  ' Fill the integer block with 0's
  For i = 0 To 255
    spInt.nValue(i) = 0
  Next
  
  ' Write the block out to the four sections of the integer area.
  ' Only 256 elements can be written at a time
  For i = 0 To 3
    nResult = gBrain.SetScratchPadIntegerArea(i * 256, 256, spInt)
    If (nResult <> SIOMM_OK) Then
      HandleError (nResult)
      Exit Sub
    End If
  Next
    
  HandleError (nResult)
  
End Sub


Private Sub ClearAllFloatsBtn_Click()
  Dim spFlt As OptoSnapIoMemMapXlib.SIOMM_ScratchPadFloatBlock
  Dim nResult As Long
  Dim i As Long

  ' Fill the float block with 0's
  For i = 0 To 255
    spFlt.fValue(i) = 0
  Next
  
  ' Write the block out to the four sections of the float area.
  ' Only 256 elements can be written at a time
  For i = 0 To 3
    nResult = gBrain.SetScratchPadFloatArea(i * 256, 256, spFlt)
    If (nResult <> SIOMM_OK) Then
      HandleError (nResult)
      Exit Sub
    End If
  Next
  
  HandleError (nResult)
  
End Sub

Private Sub ClearAllStringsBtn_Click()
  Dim spStr As OptoSnapIoMemMapXlib.SIOMM_ScratchPadStringBlock
  Dim nResult As Long
  Dim i As Long

  ' Fill the string block with empty strings
  For i = 0 To 7
    spStr.String(i).bstrString = ""
  Next
  
  ' Write the block out to the 8 sections of the string area.
  ' Only 8 elements can be written at a time
  For i = 0 To 7
    nResult = gBrain.SetScratchPadStringArea(i * 8, 8, spStr)
    If (nResult <> SIOMM_OK) Then
      HandleError (nResult)
      Exit Sub
    End If
  Next
    
  HandleError (nResult)
End Sub

Private Sub EnableConnectedControls()
    ' Disable controls that we don't want the user using while connected
    IpAddressEdit.Enabled = False
    PortNumberEdit.Enabled = False
    ConnectBtn.Enabled = False
    
    ' Enable controls that we do want the user using while connected
    DisconnectBtn.Enabled = True
    ClearAllBtn.Enabled = True
    ClearAllBitsBtn.Enabled = True
    ClearAllIntsBtn.Enabled = True
    ClearAllFloatsBtn.Enabled = True
    ClearAllStringsBtn.Enabled = True
    Grid1.Enabled = True
    Grid1.ForeColor = 0
End Sub


Private Sub DisableConnectedControls()
    IpAddressEdit.Enabled = True
    PortNumberEdit.Enabled = True
    ConnectBtn.Enabled = True
    
    DisconnectBtn.Enabled = False
    ClearAllBtn.Enabled = False
    ClearAllBitsBtn.Enabled = False
    ClearAllIntsBtn.Enabled = False
    ClearAllFloatsBtn.Enabled = False
    ClearAllStringsBtn.Enabled = False
    Grid1.Enabled = False
    Grid1.ForeColor = &H808080
End Sub


Private Sub Timer1_Timer()
  Dim nResult As Long
  Dim i As Long
  Dim j As Long
  
  ' The following structures are for retrieving the entire scratch pad aread
  Dim spBits63to32 As Long
  Dim spBits31to0 As Long
  Dim spInt(4) As OptoSnapIoMemMapXlib.SIOMM_ScratchPadIntegerBlock
  Dim spFlt(4) As OptoSnapIoMemMapXlib.SIOMM_ScratchPadFloatBlock
  Dim spStr(8) As OptoSnapIoMemMapXlib.SIOMM_ScratchPadStringBlock
  
  
  ' Get the scratch pad bit area
  nResult = gBrain.GetScratchPadBitArea(spBits63to32, spBits31to0)
  If (nResult <> SIOMM_OK) Then
    HandleError (nResult)
    Exit Sub
  End If
  
  ' Get the scratch pad integer and float area
  For i = 0 To 3
    nResult = gBrain.GetScratchPadIntegerArea(i * 256, spInt(i))
    If (nResult <> SIOMM_OK) Then
      HandleError (nResult)
      Exit Sub
    End If
    
    nResult = gBrain.GetScratchPadFloatArea(i * 256, spFlt(i))
    If (nResult <> SIOMM_OK) Then
      HandleError (nResult)
      Exit Sub
    End If
    
  Next
  
  ' Get the scratch pad string area
  For i = 0 To 7
    nResult = gBrain.GetScratchPadStringArea(i * 8, spStr(i))
    If (nResult <> SIOMM_OK) Then
      HandleError (nResult)
      Exit Sub
    End If
  Next
  
  
  ' Update the grid
  If (nResult = SIOMM_OK) Then
    
    ' Update the bit column
    For i = 0 To 31
      ' Bits 0-31
      If IsBitTrue(spBits31to0, i) Then
        Grid1.TextMatrix(i + 1, COLUMN_BITS) = 1
      Else
        Grid1.TextMatrix(i + 1, COLUMN_BITS) = 0
      End If
      
      ' Bits 32-63
      If IsBitTrue(spBits63to32, i) Then
        Grid1.TextMatrix(i + 32 + 1, COLUMN_BITS) = 1
      Else
        Grid1.TextMatrix(i + 32 + 1, COLUMN_BITS) = 0
      End If
    Next
    
    ' Update the integer and float columns
    For j = 0 To 3
      For i = 0 To 255
        Grid1.TextMatrix(i + (j * 256) + 1, COLUMN_INTS) = CStr(spInt(j).nValue(i))
        Grid1.TextMatrix(i + (j * 256) + 1, COLUMN_FLTS) = CStr(spFlt(j).fValue(i))
      Next
    Next
      
    ' Update the string columns
    For j = 0 To 7
      For i = 0 To 7
        Grid1.TextMatrix(i + (j * 8) + 1, COLUMN_STR_LEN) = CStr(spStr(j).String(i).wLength)
        Grid1.TextMatrix(i + (j * 8) + 1, COLUMN_STR_DATA) = spStr(j).String(i).bstrString
      Next
    Next
  End If
  
End Sub


Sub UpdateScratchPad()
   
  If Text1.Visible = False Then Exit Sub
   Dim nResult As Long
   nResult = SIOMM_OK
   
  Grid1 = Text1
   
  ' Hide the text control
  Text1.Visible = False
   
  ' See what column the edited element is in
  If Grid1.Col = COLUMN_BITS Then
  
    Dim spBits63to32 As Long
    Dim spBits31to0 As Long
    
    ' Find which bit needs to be changed
    If (Grid1.Row - 1) <= 31 Then
      spBits31to0 = 2 ^ (Grid1.Row - 1)
    Else
      spBits63to32 = 2 ^ (Grid1.Row - 1 - 32)
    End If
    
    ' Load the structure
    If IsNumeric(Text1) Then
      ' Check if the bit needs to be set or cleared
      If CBool(Text1) Then
        ' Set the given bit
        nResult = gBrain.SetScratchPadBitAreaMask(spBits63to32, spBits31to0, 0, 0)
      Else
        ' Clear the given bit
        nResult = gBrain.SetScratchPadBitAreaMask(0, 0, spBits63to32, spBits31to0)
      End If
    End If
    
  ElseIf Grid1.Col = COLUMN_INTS Then
  
    Dim spInt As OptoSnapIoMemMapXlib.SIOMM_ScratchPadIntegerBlock
    
    ' Load the structure
    If (IsNumeric(Text1)) Then ' make sure we have a number
      spInt.nValue(0) = CLng(Text1)
    
      ' Write just the one value
      nResult = gBrain.SetScratchPadIntegerArea(Grid1.Row - 1, 1, spInt)
    End If
    
  ElseIf Grid1.Col = COLUMN_FLTS Then
  
    Dim spFlt As OptoSnapIoMemMapXlib.SIOMM_ScratchPadFloatBlock
    
    ' Load the structure
    If (IsNumeric(Text1)) Then  ' make sure we have a number
      spFlt.fValue(0) = CLng(Text1)
    
      ' Write just the one value
      nResult = gBrain.SetScratchPadFloatArea(Grid1.Row - 1, 1, spFlt)
    End If
    
  ElseIf Grid1.Col = COLUMN_STR_DATA Then
  
    Dim spStr As OptoSnapIoMemMapXlib.SIOMM_ScratchPadStringBlock
    
    ' Load the structure
    spStr.String(0).bstrString = Text1
    
    ' Write just the one value
    nResult = gBrain.SetScratchPadStringArea(Grid1.Row - 1, 1, spStr)
  End If
   
  ' Check for error
  If (nResult <> SIOMM_OK) Then
    HandleError (nResult)
  End If
   
End Sub


Private Sub Form_Load()
  Set gBrain = New OptoSnapIoMemMapX
  Dim i As Long
  
  ' Show the "not connected" error
  HandleError (SIOMM_ERROR_NOT_CONNECTED)
  
  ' Set the initial column widths
  Grid1.ColWidth(COLUMN_BITS) = 800
  Grid1.ColWidth(COLUMN_INTS) = 1200
  Grid1.ColWidth(COLUMN_FLTS) = 1200
  Grid1.ColWidth(COLUMN_STR_LEN) = 1200
  Grid1.ColWidth(COLUMN_STR_DATA) = 4500
  
  ' Set the column names
  Grid1.TextMatrix(0, COLUMN_BITS) = "Bits"
  Grid1.TextMatrix(0, COLUMN_INTS) = "Integers"
  Grid1.TextMatrix(0, COLUMN_FLTS) = "Floats"
  Grid1.TextMatrix(0, COLUMN_STR_LEN) = "Str Length"
  Grid1.TextMatrix(0, COLUMN_STR_DATA) = "String Data"
  
  ' Set the first column
  For i = 0 To 1023
    Grid1.TextMatrix(i + 1, 0) = CStr(i)
  Next
  
  ' Initialize edit box (so it loads now).
  Text1 = ""
  
  DisableConnectedControls
  
End Sub


Private Sub Form_Unload(Cancel As Integer)
  ' Stop the timer
  Timer1.Enabled = False
  
  ' Close the connection to the brain
  Call gBrain.Close
  
  ' Close all forms
  Dim i As Integer
  For i = Forms.Count - 1 To 1 Step -1
      Unload Forms(i)
  Next
  
End Sub



' The following code is for making the flexgrid control editable.
' It has nothing directly to do with the example.
' It is based on the article "Editing Cells in a Hierarchical FlexGrid Spreadsheet"
' in the VB 6.0 documentation.

  Sub Text1_KeyPress(KeyAscii As Integer)
     ' Delete returns to get rid of beep.
     If KeyAscii = Asc(vbCr) Then KeyAscii = 0
  End Sub
  
  Sub Text1_KeyDown(KeyCode As Integer, Shift As Integer)
     EditKeyCode Grid1, Text1, KeyCode, Shift
  End Sub
  
  Function Fgi(r As Integer, c As Integer) As Integer
     Fgi = c + Grid1.Cols * r
  End Function
  
  Sub Grid1_KeyPress(KeyAscii As Integer)
     MSFlexGridEdit Grid1, Text1, KeyAscii
  End Sub
  
  Sub Grid1_DblClick()
     MSFlexGridEdit Grid1, Text1, 32 ' Simulate a space.
  End Sub
  
  Sub MSFlexGridEdit(MSFlexGrid As Control, Edt As Control, KeyAscii As Integer)
  
     ' Use the character that was typed.
     Select Case KeyAscii
  
       ' A space means edit the current text.
       Case 0 To 32
          Edt = MSFlexGrid
          Edt.SelStart = 0
    
       ' Anything else means replace the current text.
       Case Else
          Edt = Chr(KeyAscii)
          Edt.SelStart = 1
     End Select
  
     ' Show Edt at the right place.
     Edt.Move MSFlexGrid.Left + MSFlexGrid.CellLeft, _
        MSFlexGrid.Top + MSFlexGrid.CellTop, _
        MSFlexGrid.CellWidth - 8, _
        MSFlexGrid.CellHeight - 8
     
     ' And make it work.
     Edt.Visible = True
     Edt.SetFocus
  End Sub
  
  Sub EditKeyCode(MSFlexGrid As Control, Edt As Control, KeyCode As Integer, Shift As Integer)
  
     ' Standard edit control processing.
     Select Case KeyCode
  
     Case 27   ' ESC: hide, return focus to MSFlexGrid.
        Edt.Visible = False
        MSFlexGrid.SetFocus
  
     Case 13   ' ENTER return focus to MSFlexGrid.
        MSFlexGrid.SetFocus
  
     Case 38      ' Up.
        MSFlexGrid.SetFocus
        DoEvents
        If MSFlexGrid.Row > MSFlexGrid.FixedRows Then
           MSFlexGrid.Row = MSFlexGrid.Row - 1
        End If
  
     Case 40      ' Down.
        MSFlexGrid.SetFocus
        DoEvents
        If MSFlexGrid.Row < MSFlexGrid.Rows - 1 Then
           MSFlexGrid.Row = MSFlexGrid.Row + 1
        End If
     End Select
  End Sub
  
  Private Sub Grid1_LeaveCell()
    UpdateScratchPad
  End Sub
  
  Sub Grid1_GotFocus()
    UpdateScratchPad
  End Sub
  
  
