VERSION 5.00
Begin VB.Form frmStreamReadArea 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Form1"
   ClientHeight    =   6570
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   11475
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   6570
   ScaleWidth      =   11475
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin VB.Timer Timer1 
      Interval        =   250
      Left            =   2280
      Top             =   6000
   End
   Begin VB.CommandButton CloseBtn 
      Caption         =   "&Close"
      Default         =   -1  'True
      Height          =   375
      Left            =   120
      TabIndex        =   1
      Top             =   6000
      Width           =   1335
   End
   Begin VB.TextBox OutputEdit 
      BackColor       =   &H80000016&
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   5295
      Left            =   120
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      TabIndex        =   0
      Text            =   "frmStreamReadArea.frx":0000
      Top             =   480
      Width           =   11175
   End
   Begin VB.Label Label1 
      Caption         =   "Stream Read Area"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   240
      Width           =   5055
   End
End
Attribute VB_Name = "frmStreamReadArea"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Sub CloseBtn_Click()
  Unload Me
End Sub

Private Sub Form_Unload(Cancel As Integer)
  ' Turn the timer off
  Timer1.Enabled = False
End Sub

Private Sub Timer1_Timer()
  Dim nResult As Long
  Dim StreamArea As OptoSnapIoMemMapXLib.SIOMM_StreamStandardBlock
  
  OutputEdit.Text = ""
  
  nResult = gBrain.GetStreamReadAreaEx(StreamArea)
  
  If (nResult = SIOMM_OK) Then
    Dim i As Long
    
    ' Analog Points
    For i = 0 To 63 Step 8
      OutputEdit.Text = OutputEdit.Text + _
                        "Analog Points " + Format(i, "00") + "-" + Format(i + 7, "00") + ":   " + _
                        Right("          " + Format(StreamArea.fAnalogValue(i + 0), "#0.00"), 10) + _
                        Right("          " + Format(StreamArea.fAnalogValue(i + 1), "#0.00"), 10) + _
                        Right("          " + Format(StreamArea.fAnalogValue(i + 2), "#0.00"), 10) + _
                        Right("          " + Format(StreamArea.fAnalogValue(i + 3), "#0.00"), 10) + _
                        Right("          " + Format(StreamArea.fAnalogValue(i + 4), "#0.00"), 10) + _
                        Right("          " + Format(StreamArea.fAnalogValue(i + 5), "#0.00"), 10) + _
                        Right("          " + Format(StreamArea.fAnalogValue(i + 6), "#0.00"), 10) + _
                        Right("          " + Format(StreamArea.fAnalogValue(i + 7), "#0.00"), 10) + Chr$(13) + Chr$(10)
    
    Next i
    
    OutputEdit.Text = OutputEdit.Text + Chr$(13) + Chr$(10)
  
    ' Digital Features
    For i = 0 To 63 Step 8
      OutputEdit.Text = OutputEdit.Text + _
                        "Digital Feature " + Format(i, "00") + "-" + Format(i + 7, "00") + ": " + _
                        Right("          " + Format(StreamArea.nDigPointFeature(i + 0), "#0"), 10) + _
                        Right("          " + Format(StreamArea.nDigPointFeature(i + 1), "#0"), 10) + _
                        Right("          " + Format(StreamArea.nDigPointFeature(i + 2), "#0"), 10) + _
                        Right("          " + Format(StreamArea.nDigPointFeature(i + 3), "#0"), 10) + _
                        Right("          " + Format(StreamArea.nDigPointFeature(i + 4), "#0"), 10) + _
                        Right("          " + Format(StreamArea.nDigPointFeature(i + 5), "#0"), 10) + _
                        Right("          " + Format(StreamArea.nDigPointFeature(i + 6), "#0"), 10) + _
                        Right("          " + Format(StreamArea.nDigPointFeature(i + 7), "#0"), 10) + Chr$(13) + Chr$(10)
    
    Next i
  
    OutputEdit.Text = OutputEdit.Text + Chr$(13) + Chr$(10)
  
    OutputEdit.Text = OutputEdit.Text + "Digital Point States:           " + "0x" + FormatHexString(StreamArea.nStatePts63to32) + FormatHexString(StreamArea.nStatePts31to0) + Chr$(13) + Chr$(10)
    OutputEdit.Text = OutputEdit.Text + "Digital Point On-Latch States:  " + "0x" + FormatHexString(StreamArea.nOnLatchStatePts63to32) + FormatHexString(StreamArea.nOnLatchStatePts31to0) + Chr$(13) + Chr$(10)
    OutputEdit.Text = OutputEdit.Text + "Digital Point Off-Latch States: " + "0x" + FormatHexString(StreamArea.nOffLatchStatePts63to32) + FormatHexString(StreamArea.nOffLatchStatePts31to0) + Chr$(13) + Chr$(10)
    OutputEdit.Text = OutputEdit.Text + "Digital Point Active Counters:  " + "0x" + FormatHexString(StreamArea.nActiveCountersPts63to32) + FormatHexString(StreamArea.nActiveCountersPts31to0) + Chr$(13) + Chr$(10)
  
  
  End If
  

End Sub
