VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "OptoSnapIoMemMapX Performance Tester"
   ClientHeight    =   4590
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   9600
   LinkTopic       =   "Form1"
   ScaleHeight     =   4590
   ScaleWidth      =   9600
   StartUpPosition =   2  'CenterScreen
   Begin VB.Frame Frame4 
      Caption         =   "Tests"
      Height          =   4215
      Left            =   2520
      TabIndex        =   9
      Top             =   120
      Width           =   6855
      Begin VB.TextBox Test3Edit 
         BackColor       =   &H80000016&
         BeginProperty Font 
            Name            =   "Courier New"
            Size            =   9.75
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   645
         Left            =   2280
         Locked          =   -1  'True
         MultiLine       =   -1  'True
         TabIndex        =   15
         Top             =   2640
         Width           =   4335
      End
      Begin VB.CommandButton Command1 
         Caption         =   "Run Tests"
         Height          =   375
         Left            =   240
         TabIndex        =   14
         Top             =   360
         Width           =   1335
      End
      Begin VB.TextBox Test2Edit 
         BackColor       =   &H80000016&
         BeginProperty Font 
            Name            =   "Courier New"
            Size            =   9.75
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   645
         Left            =   2280
         Locked          =   -1  'True
         MultiLine       =   -1  'True
         TabIndex        =   13
         Top             =   1800
         Width           =   4335
      End
      Begin VB.TextBox Test1Edit 
         BackColor       =   &H80000016&
         BeginProperty Font 
            Name            =   "Courier New"
            Size            =   9.75
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   645
         Left            =   2280
         Locked          =   -1  'True
         MultiLine       =   -1  'True
         TabIndex        =   10
         Top             =   960
         Width           =   4335
      End
      Begin VB.Label Label4 
         Caption         =   "GetAnaBankValuesEx()"
         Height          =   255
         Left            =   240
         TabIndex        =   16
         Top             =   2760
         Width           =   1935
      End
      Begin VB.Label Label11 
         Caption         =   "GetDigBankPointStates()"
         Height          =   255
         Left            =   240
         TabIndex        =   12
         Top             =   1080
         Width           =   1815
      End
      Begin VB.Label Label10 
         Caption         =   "VGetDigBankPointStates()"
         Height          =   255
         Left            =   240
         TabIndex        =   11
         Top             =   1920
         Width           =   1935
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Configuration"
      Height          =   2895
      Left            =   120
      TabIndex        =   2
      Top             =   120
      Width           =   2175
      Begin VB.TextBox IpAddressEdit 
         Height          =   285
         Left            =   240
         TabIndex        =   6
         Text            =   "10.192.54.0"
         Top             =   600
         Width           =   1575
      End
      Begin VB.CommandButton ConnectBtn 
         Caption         =   "Connect"
         Height          =   375
         Left            =   240
         TabIndex        =   5
         Top             =   1800
         Width           =   1455
      End
      Begin VB.CommandButton DisconnectBtn 
         Caption         =   "Disconnect"
         Height          =   375
         Left            =   240
         TabIndex        =   4
         Top             =   2280
         Width           =   1455
      End
      Begin VB.TextBox PortNumberEdit 
         Height          =   285
         Left            =   240
         TabIndex        =   3
         Text            =   "2001"
         Top             =   1320
         Width           =   1575
      End
      Begin VB.Label Label1 
         Caption         =   "IP Address of Snap I/O:"
         Height          =   255
         Left            =   240
         TabIndex        =   8
         Top             =   360
         Width           =   1815
      End
      Begin VB.Label Label2 
         Caption         =   "Port Number:"
         Height          =   255
         Left            =   240
         TabIndex        =   7
         Top             =   1080
         Width           =   1575
      End
   End
   Begin VB.Frame Frame2 
      Caption         =   "Status"
      Height          =   1215
      Left            =   120
      TabIndex        =   0
      Top             =   3120
      Width           =   2055
      Begin VB.TextBox ErrorEdit 
         BackColor       =   &H00FFFFFF&
         Height          =   525
         Left            =   240
         MultiLine       =   -1  'True
         TabIndex        =   1
         Top             =   360
         Width           =   1575
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function GetTickCount Lib "kernel32" () As Long

Public gBrain As OptoSnapIoMemMapX

Public Sub HandleError(nResult As Long)
  ' Update the error message
  ErrorEdit.Text = GetResultAsString(nResult)
  
  If (nResult = SIOMM_OK) Then
    ' Set background to white
    ErrorEdit.BackColor = &HFFFFFF
  Else
    ' Set background to red
    ErrorEdit.BackColor = &HFF&
    
    ' shutdown everything on a bad error
    If (nResult <> SIOMM_ERROR_NOT_CONNECTED_YET) Then
      gBrain.Close
    End If
  End If
End Sub


Private Sub Command1_Click()
  Dim v63to32Part As Variant
  Dim v31to0Part As Variant
  Dim vResult As Variant
  Dim n63to32Part As Long
  Dim n31to0Part As Long
  Dim nResult As Long
  Dim AnalogBank As SIOMM_AnaBank
  Dim i As Long
  Dim Loops As Long
  Dim nStartTime As Long
  Dim nStopTime As Long
  
  Loops = 500
  
  ' Show the hourglass cursor
  Me.MousePointer = 11
  
  ' Test 1
  nStartTime = GetTickCount()
  For i = 0 To Loops
    nResult = gBrain.GetDigBankPointStates(n63to32Part, n31to0Part)
    If (nResult <> 1) Then
      GoTo bail: ' bail on error
    End If
  Next i
  nStopTime = GetTickCount()
  
  ' Print results of test 1
  Test1Edit = Format(Loops / ((nStopTime - nStartTime) / 1000), "0.00") + " transactions per second" _
              + Chr(13) + Chr(10) _
              + Format(((nStopTime - nStartTime) / Loops), "0.00") + " millisecond average update"

  ' Test 2
  nStartTime = GetTickCount()
  For i = 0 To Loops
    vResult = gBrain.VGetDigBankPointStates(v63to32Part, v31to0Part)
    If (nResult <> 1) Then
      GoTo bail: ' bail on error
    End If
  Next i
  nStopTime = GetTickCount()
  
  ' Print results of test 2
  Test2Edit = Format(Loops / ((nStopTime - nStartTime) / 1000), "0.00") + " transactions per second" _
              + Chr(13) + Chr(10) _
              + Format(((nStopTime - nStartTime) / Loops), "0.00") + " millisecond average update"
  
  
  ' Test 3
  nStartTime = GetTickCount()
  For i = 0 To Loops
    nResult = gBrain.GetAnaBankValuesEx(AnalogBank)
    If (nResult <> 1) Then
      GoTo bail: ' bail on error
    End If
  Next i
  nStopTime = GetTickCount()
  
  ' Print results of test 3
  Test3Edit = Format(Loops / ((nStopTime - nStartTime) / 1000), "0.00") + " transactions per second" _
              + Chr(13) + Chr(10) _
              + Format(((nStopTime - nStartTime) / Loops), "0.00") + " millisecond average update"
  
  
bail:
  If (nResult <> 1) Then
    Test1Edit = "Test aborted"
    Test2Edit = "Test aborted"
    Test3Edit = "Test aborted"
  End If

  ' Show the normal cursor
  Me.MousePointer = 0

End Sub

Private Sub ConnectBtn_Click()
  Dim nResult As Long
  
  
  ' Attempt to open the Snap I/O...
  nResult = OpenSnapIoWithCancel(gBrain, IpAddressEdit.Text, PortNumberEdit.Text, 10000)
  
  ' Check the result
  HandleError (nResult)
  
End Sub


Private Sub DisconnectBtn_Click()
  HandleError (gBrain.Close())
End Sub


Private Sub Form_Load()
  Set gBrain = New OptoSnapIoMemMapX
End Sub

Private Sub Form_Unload(Cancel As Integer)
  Call gBrain.Close
  Set gBrain = Nothing
  
  'close all forms
  Dim i As Integer
  For i = Forms.Count - 1 To 1 Step -1
    Unload Forms(i)
  Next
    
End Sub



